# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class CbCall(Base):
    """可转债赎回信息"""

    __tablename__: str = "cb_call"
    __api_id__: ClassVar[int] = 269
    __api_name__: ClassVar[str] = "cb_call"
    __api_title__: ClassVar[str] = "可转债赎回信息"
    __api_info_title__: ClassVar[str] = "可转债赎回信息"
    __api_path__: ClassVar[List[str]] = ["数据接口", "债券专题", "可转债赎回信息"]
    __api_path_ids__: ClassVar[List[int]] = [2, 184, 269]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "call_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "转债代码，支持多值输入"},
        "ann_date": {"type": "str", "required": False, "description": "公告日期"},
        "start_date": {"type": "str", "required": False, "description": "公告开始日期"},
        "end_date": {"type": "str", "required": False, "description": "公告结束日期"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "可转债赎回信息",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="转债代码")
    call_type = Column(
        "call_type", String(), nullable=False, default="", server_default=text("''"), comment="赎回类型：到赎、强赎"
    )
    is_call = Column(
        "is_call",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="是否赎回：公告到期赎回、公告强赎、公告不强赎",
    )
    ann_date = Column(
        "ann_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="公告日期"
    )
    call_date = Column(
        "call_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="赎回日期"
    )
    call_price = Column(
        "call_price", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="赎回价格(含税，元/张)"
    )
    call_price_tax = Column(
        "call_price_tax",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="赎回价格(扣税，元/张)",
    )
    call_vol = Column(
        "call_vol", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="赎回债券数量(张)"
    )
    call_amount = Column(
        "call_amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="赎回金额(万元)"
    )
    payment_date = Column(
        "payment_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="行权后款项到账日",
    )
    call_reg_date = Column(
        "call_reg_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="赎回登记日",
    )
