# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class CbRate(Base):
    """可转债票面利率"""

    __tablename__: str = "cb_rate"
    __api_id__: ClassVar[int] = 305
    __api_name__: ClassVar[str] = "cb_rate"
    __api_title__: ClassVar[str] = "可转债票面利率"
    __api_info_title__: ClassVar[str] = "可转债票面利率"
    __api_path__: ClassVar[List[str]] = ["数据接口", "债券专题", "可转债票面利率"]
    __api_path_ids__: ClassVar[List[int]] = [2, 184, 305]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "rate_start_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "转债代码，支持多值输入"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "可转债票面利率",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="转债代码")
    rate_freq = Column(
        "rate_freq", Integer, nullable=False, default=0, server_default=text("'0'"), comment="付息频率(次/年)"
    )
    rate_start_date = Column(
        "rate_start_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="纯债价值",
    )
    rate_end_date = Column(
        "rate_end_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="纯债溢价率(%)",
    )
    coupon_rate = Column(
        "coupon_rate", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="票面利率(%)"
    )
