# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class ConceptDetail(Base):
    """概念股明细列表"""

    __tablename__: str = "concept_detail"
    __api_id__: ClassVar[int] = 126
    __api_name__: ClassVar[str] = "concept_detail"
    __api_title__: ClassVar[str] = "概念股明细列表"
    __api_info_title__: ClassVar[str] = "概念股列表"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "参考数据", "概念股明细列表"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 17, 126]
    __api_points_required__: ClassVar[int] = 5000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = ["concept"]
    __primary_key__: ClassVar[List[str]] = ["ts_code", "id"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "id": {"type": "str", "required": False, "description": "概念分类ID"},
        "ts_code": {"type": "str", "required": False, "description": "股票代码"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "概念股明细列表",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    id = Column("id", String(), nullable=False, default="", server_default=text("''"), comment="概念代码")
    concept_name = Column(
        "concept_name", String(), nullable=False, default="", server_default=text("''"), comment="概念名称"
    )
    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="股票代码")
    name = Column("name", String(), nullable=False, default="", server_default=text("''"), comment="股票名称")
    in_date = Column(
        "in_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="纳入日期"
    )
    out_date = Column(
        "out_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="剔除日期"
    )
