# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class DcMember(Base):
    """东方财富概念成分"""

    __tablename__: str = "dc_member"
    __api_id__: ClassVar[int] = 363
    __api_name__: ClassVar[str] = "dc_member"
    __api_title__: ClassVar[str] = "东方财富概念成分"
    __api_info_title__: ClassVar[str] = "东方财富板块成分"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "打板专题数据", "东方财富概念成分"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 346, 363]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "trade_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "trade_date": {"type": "str", "required": False, "description": "交易日期（YYYYMMDD格式）"},
        "ts_code": {"type": "str", "required": False, "description": "板块指数代码"},
        "con_code": {"type": "str", "required": False, "description": "成分股票代码"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "东方财富概念成分",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    trade_date = Column(
        "trade_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="交易日期",
    )
    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="概念代码")
    con_code = Column("con_code", String(), nullable=False, default="", server_default=text("''"), comment="成分代码")
    name = Column("name", String(), nullable=False, default="", server_default=text("''"), comment="成分股名称")
