# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class Forecast(Base):
    """业绩预告"""

    __tablename__: str = "forecast"
    __api_id__: ClassVar[int] = 45
    __api_name__: ClassVar[str] = "forecast"
    __api_title__: ClassVar[str] = "业绩预告"
    __api_info_title__: ClassVar[str] = "业绩预告"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "财务数据", "业绩预告"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 16, 45]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = True
    __dependencies__: ClassVar[List[str]] = ["stock_basic"]
    __primary_key__: ClassVar[List[str]] = ["ts_code", "ann_date", "end_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "股票代码"},
        "ann_date": {"type": "str", "required": False, "description": "公告日期"},
        "start_date": {"type": "str", "required": False, "description": "公告开始日期"},
        "end_date": {"type": "str", "required": False, "description": "公告结束日期"},
        "period": {"type": "str", "required": False, "description": "报告期"},
        "type": {"type": "str", "required": False, "description": "预告类型"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "业绩预告",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="TS股票代码")
    ann_date = Column(
        "ann_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="公告日期"
    )
    end_date = Column(
        "end_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="报告期"
    )
    type = Column("type", String(), nullable=False, default="", server_default=text("''"), comment="业绩预告类型")
    p_change_min = Column(
        "p_change_min",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="预告净利润变动幅度下限(%)",
    )
    p_change_max = Column(
        "p_change_max",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="预告净利润变动幅度上限(%)",
    )
    net_profit_min = Column(
        "net_profit_min",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="预告净利润下限(万元)",
    )
    net_profit_max = Column(
        "net_profit_max",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="预告净利润上限(万元)",
    )
    last_parent_net = Column(
        "last_parent_net",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="上年同期归属母公司净利润",
    )
    notice_times = Column(
        "notice_times", Integer, nullable=False, default=0, server_default=text("'0'"), comment="公布次数"
    )
    first_ann_date = Column(
        "first_ann_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="首次公告日",
    )
    summary = Column("summary", String(), nullable=False, default="", server_default=text("''"), comment="业绩预告摘要")
    change_reason = Column(
        "change_reason", String(), nullable=False, default="", server_default=text("''"), comment="业绩变动原因"
    )
    update_flag = Column(
        "update_flag", String(), nullable=False, default="", server_default=text("''"), comment="更新标志"
    )
