# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class FundBasic(Base):
    """基金列表"""

    __tablename__: str = "fund_basic"
    __api_id__: ClassVar[int] = 19
    __api_name__: ClassVar[str] = "fund_basic"
    __api_title__: ClassVar[str] = "基金列表"
    __api_info_title__: ClassVar[str] = "公募基金列表"
    __api_path__: ClassVar[List[str]] = ["数据接口", "公募基金", "基金列表"]
    __api_path_ids__: ClassVar[List[int]] = [2, 18, 19]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "TS基金代码"},
        "market": {"type": "str", "required": False, "description": "交易市场"},
        "update_flag": {"type": "str", "required": False, "description": "更新标志"},
        "offset": {"type": "int", "required": False, "description": ""},
        "limit": {"type": "int", "required": False, "description": ""},
        "status": {"type": "str", "required": False, "description": "存续状态"},
        "name": {"type": "str", "required": False, "description": ""},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "基金列表",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="基金代码")
    name = Column("name", String(), nullable=False, default="", server_default=text("''"), comment="简称")
    management = Column("management", String(), nullable=False, default="", server_default=text("''"), comment="管理人")
    custodian = Column("custodian", String(), nullable=False, default="", server_default=text("''"), comment="托管人")
    fund_type = Column("fund_type", String(), nullable=False, default="", server_default=text("''"), comment="投资类型")
    found_date = Column(
        "found_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="成立日期",
    )
    due_date = Column(
        "due_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="到期日期"
    )
    list_date = Column(
        "list_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="上市时间"
    )
    issue_date = Column(
        "issue_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="发行日期",
    )
    delist_date = Column(
        "delist_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="退市日期",
    )
    issue_amount = Column(
        "issue_amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="发行份额(亿份)"
    )
    m_fee = Column("m_fee", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="管理费")
    c_fee = Column("c_fee", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="托管费")
    duration_year = Column(
        "duration_year", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="存续期"
    )
    p_value = Column("p_value", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="面值")
    min_amount = Column(
        "min_amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="起点金额(万元)"
    )
    exp_return = Column(
        "exp_return", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="预期收益率"
    )
    benchmark = Column(
        "benchmark", String(), nullable=False, default="", server_default=text("''"), comment="业绩比较基准"
    )
    status = Column(
        "status", String(), nullable=False, default="", server_default=text("''"), comment="存续状态D摘牌 I发行 L已上市"
    )
    invest_type = Column(
        "invest_type", String(), nullable=False, default="", server_default=text("''"), comment="投资风格"
    )
    type = Column("type", String(), nullable=False, default="", server_default=text("''"), comment="基金类型")
    trustee = Column("trustee", String(), nullable=False, default="", server_default=text("''"), comment="受托人")
    purc_startdate = Column(
        "purc_startdate", String(), nullable=False, default="", server_default=text("''"), comment="日常申购起始日"
    )
    redm_startdate = Column(
        "redm_startdate", String(), nullable=False, default="", server_default=text("''"), comment="日常赎回起始日"
    )
    market = Column("market", String(), nullable=False, default="", server_default=text("''"), comment="E场内O场外")
