# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class FundNav(Base):
    """基金净值"""

    __tablename__: str = "fund_nav"
    __api_id__: ClassVar[int] = 119
    __api_name__: ClassVar[str] = "fund_nav"
    __api_title__: ClassVar[str] = "基金净值"
    __api_info_title__: ClassVar[str] = "公募基金净值"
    __api_path__: ClassVar[List[str]] = ["数据接口", "公募基金", "基金净值"]
    __api_path_ids__: ClassVar[List[int]] = [2, 18, 119]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "nav_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "TS基金代码"},
        "nav_date": {"type": "str", "required": False, "description": "净值日期"},
        "offset": {"type": "int", "required": False, "description": ""},
        "limit": {"type": "int", "required": False, "description": ""},
        "market": {"type": "str", "required": False, "description": "E场内O场外"},
        "start_date": {"type": "str", "required": False, "description": "净值开始日期"},
        "end_date": {"type": "str", "required": False, "description": "净值结束日期"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "基金净值",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="TS代码")
    ann_date = Column(
        "ann_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="公告日期"
    )
    nav_date = Column(
        "nav_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="截止日期"
    )
    unit_nav = Column("unit_nav", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="单位净值")
    accum_nav = Column(
        "accum_nav", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="累计净值"
    )
    accum_div = Column(
        "accum_div", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="累计分红"
    )
    net_asset = Column(
        "net_asset", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="资产净值"
    )
    total_netasset = Column(
        "total_netasset", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="合计资产净值"
    )
    adj_nav = Column(
        "adj_nav", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="复权单位净值"
    )
    update_flag = Column(
        "update_flag", String(), nullable=False, default="", server_default=text("''"), comment="更新标识"
    )
