# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class FundPortfolio(Base):
    """基金持仓"""

    __tablename__: str = "fund_portfolio"
    __api_id__: ClassVar[int] = 121
    __api_name__: ClassVar[str] = "fund_portfolio"
    __api_title__: ClassVar[str] = "基金持仓"
    __api_info_title__: ClassVar[str] = "公募基金持仓数据"
    __api_path__: ClassVar[List[str]] = ["数据接口", "公募基金", "基金持仓"]
    __api_path_ids__: ClassVar[List[int]] = [2, 18, 121]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "end_date", "symbol"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "基金代码"},
        "ann_date": {"type": "str", "required": False, "description": "公告日期"},
        "start_date": {"type": "str", "required": False, "description": "公告开始日期"},
        "end_date": {"type": "str", "required": False, "description": "公告结束日期"},
        "period": {"type": "str", "required": False, "description": "报告期"},
        "symbol": {"type": "str", "required": False, "description": "股票代码"},
        "offset": {"type": "int", "required": False, "description": ""},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "基金持仓",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="TS基金代码")
    ann_date = Column(
        "ann_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="公告日期"
    )
    end_date = Column(
        "end_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="截止日期"
    )
    symbol = Column("symbol", String(), nullable=False, default="", server_default=text("''"), comment="股票代码")
    mkv = Column("mkv", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="持有股票市值(元)")
    amount = Column(
        "amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="持有股票数量(股)"
    )
    stk_mkv_ratio = Column(
        "stk_mkv_ratio", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="占股票市值比"
    )
    stk_float_ratio = Column(
        "stk_float_ratio", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="占流通股本比例"
    )
