# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class FundSalesRatio(Base):
    """各渠道公募基金销售保有规模占比"""

    __tablename__: str = "fund_sales_ratio"
    __api_id__: ClassVar[int] = 265
    __api_name__: ClassVar[str] = "fund_sales_ratio"
    __api_title__: ClassVar[str] = "各渠道公募基金销售保有规模占比"
    __api_info_title__: ClassVar[str] = "各渠道公募基金销售保有规模占比"
    __api_path__: ClassVar[List[str]] = ["数据接口", "财富管理", "基金销售行业数据", "各渠道公募基金销售保有规模占比"]
    __api_path_ids__: ClassVar[List[int]] = [2, 263, 264, 265]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["year"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "年份": {"type": "str", "required": False, "description": "年度"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "各渠道公募基金销售保有规模占比",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    year = Column("year", Integer, nullable=False, default=0, server_default=text("'0'"), comment="年度")
    bank = Column("bank", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="商业银行(%)")
    sec_comp = Column(
        "sec_comp", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="证券公司(%)"
    )
    fund_comp = Column(
        "fund_comp", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="基金公司直销(%)"
    )
    indep_comp = Column(
        "indep_comp", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="独立基金销售机构(%)"
    )
    rests = Column("rests", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="其他(%)")
