# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class FutBasic(Base):
    """合约信息"""

    __tablename__: str = "fut_basic"
    __api_id__: ClassVar[int] = 135
    __api_name__: ClassVar[str] = "fut_basic"
    __api_title__: ClassVar[str] = "合约信息"
    __api_info_title__: ClassVar[str] = "期货合约信息表"
    __api_path__: ClassVar[List[str]] = ["数据接口", "期货数据", "合约信息"]
    __api_path_ids__: ClassVar[List[int]] = [2, 134, 135]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "exchange": {"type": "str", "required": True, "description": "交易所代码"},
        "fut_type": {"type": "str", "required": False, "description": "合约类型"},
        "ts_code": {"type": "str", "required": False, "description": "合约代码"},
        "fut_code": {"type": "str", "required": False, "description": "标准合约代码"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "合约信息",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="")
    symbol = Column("symbol", String(), nullable=False, default="", server_default=text("''"), comment="交易代码")
    exchange = Column("exchange", String(), nullable=False, default="", server_default=text("''"), comment="交易市场")
    name = Column("name", String(), nullable=False, default="", server_default=text("''"), comment="中文简称")
    fut_code = Column(
        "fut_code", String(), nullable=False, default="", server_default=text("''"), comment="合约产品代码"
    )
    multiplier = Column(
        "multiplier", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="合约乘数"
    )
    trade_unit = Column(
        "trade_unit", String(), nullable=False, default="", server_default=text("''"), comment="交易计量单位"
    )
    per_unit = Column(
        "per_unit", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="交易单位(每手)"
    )
    quote_unit = Column(
        "quote_unit", String(), nullable=False, default="", server_default=text("''"), comment="报价单位"
    )
    quote_unit_desc = Column(
        "quote_unit_desc", String(), nullable=False, default="", server_default=text("''"), comment="最小报价单位说明"
    )
    d_mode_desc = Column(
        "d_mode_desc", String(), nullable=False, default="", server_default=text("''"), comment="交割方式说明"
    )
    list_date = Column(
        "list_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="上市日期"
    )
    delist_date = Column(
        "delist_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="最后交易日期",
    )
    d_month = Column("d_month", String(), nullable=False, default="", server_default=text("''"), comment="交割月份")
    last_ddate = Column(
        "last_ddate", String(), nullable=False, default="", server_default=text("''"), comment="最后交割日"
    )
    trade_time_desc = Column(
        "trade_time_desc", String(), nullable=False, default="", server_default=text("''"), comment="交易时间说明"
    )
