# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class FxDaily(Base):
    """外汇日线行情"""

    __tablename__: str = "fx_daily"
    __api_id__: ClassVar[int] = 179
    __api_name__: ClassVar[str] = "fx_daily"
    __api_title__: ClassVar[str] = "外汇日线行情"
    __api_info_title__: ClassVar[str] = "外汇日线行情"
    __api_path__: ClassVar[List[str]] = ["数据接口", "外汇数据", "外汇日线行情"]
    __api_path_ids__: ClassVar[List[int]] = [2, 177, 179]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "trade_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "TS代码"},
        "trade_date": {"type": "str", "required": False, "description": "交易日期（GMT）"},
        "start_date": {"type": "str", "required": False, "description": "开始日期（GMT）"},
        "end_date": {"type": "str", "required": False, "description": "结束日期（GMT）"},
        "exchange": {"type": "str", "required": False, "description": "交易商"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "外汇日线行情",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="外汇代码")
    trade_date = Column(
        "trade_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="交易日期",
    )
    bid_open = Column(
        "bid_open", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="买入开盘价"
    )
    bid_close = Column(
        "bid_close", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="买入收盘价"
    )
    bid_high = Column(
        "bid_high", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="买入最高价"
    )
    bid_low = Column("bid_low", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="买入最低价")
    ask_open = Column(
        "ask_open", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="卖出开盘价"
    )
    ask_close = Column(
        "ask_close", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="卖出收盘价"
    )
    ask_high = Column(
        "ask_high", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="卖出最高价"
    )
    ask_low = Column("ask_low", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="卖出最低价")
    tick_qty = Column("tick_qty", Integer, nullable=False, default=0, server_default=text("'0'"), comment="报价笔数")
    exchange = Column("exchange", String(), nullable=False, default="", server_default=text("''"), comment="交易商")
