# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class GgtMonthly(Base):
    """港股通每月成交统计"""

    __tablename__: str = "ggt_monthly"
    __api_id__: ClassVar[int] = 197
    __api_name__: ClassVar[str] = "ggt_monthly"
    __api_title__: ClassVar[str] = "港股通每月成交统计"
    __api_info_title__: ClassVar[str] = "港股通每月成交统计"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "行情数据", "港股通每月成交统计"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 15, 197]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["month"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "month": {"type": "str", "required": False, "description": "月度"},
        "start_month": {"type": "str", "required": False, "description": "开始月度"},
        "end_month": {"type": "str", "required": False, "description": "结束月度"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "港股通每月成交统计",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    month = Column("month", String(), nullable=False, default="", server_default=text("''"), comment="交易日期")
    day_buy_amt = Column(
        "day_buy_amt",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="当月日均买入成交金额(亿元)",
    )
    day_buy_vol = Column(
        "day_buy_vol",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="当月日均买入成交笔数(万笔)",
    )
    day_sell_amt = Column(
        "day_sell_amt",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="当月日均卖出成交金额(亿元)",
    )
    day_sell_vol = Column(
        "day_sell_vol",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="当月日均卖出成交笔数(万笔)",
    )
    total_buy_amt = Column(
        "total_buy_amt",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="总买入成交金额(亿元)",
    )
    total_buy_vol = Column(
        "total_buy_vol",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="总买入成交笔数(万笔)",
    )
    total_sell_amt = Column(
        "total_sell_amt",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="总卖出成交金额(亿元)",
    )
    total_sell_vol = Column(
        "total_sell_vol",
        Float,
        nullable=False,
        default=0.0,
        server_default=text("'0.0'"),
        comment="总卖出成交笔数(万笔)",
    )
