# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class IndexMember(Base):
    """申万行业成分构成"""

    __tablename__: str = "index_member"
    __api_id__: ClassVar[int] = 182
    __api_name__: ClassVar[str] = "index_member"
    __api_title__: ClassVar[str] = "申万行业成分构成"
    __api_info_title__: ClassVar[str] = "申万行业成分构成"
    __api_path__: ClassVar[List[str]] = ["申万行业成分构成"]
    __api_path_ids__: ClassVar[List[int]] = []
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["index_code", "is_new"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "index_code": {"type": "str", "required": False, "description": "指数代码"},
        "is_new": {"type": "str", "required": False, "description": "是否最新"},
        "ts_code": {"type": "str", "required": False, "description": "股票代码"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "申万行业成分构成",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    index_code = Column(
        "index_code", String(), nullable=False, default="", server_default=text("''"), comment="指数代码"
    )
    index_name = Column(
        "index_name", String(), nullable=False, default="", server_default=text("''"), comment="指数名称"
    )
    con_code = Column(
        "con_code", String(), nullable=False, default="", server_default=text("''"), comment="成分股票代码"
    )
    con_name = Column(
        "con_name", String(), nullable=False, default="", server_default=text("''"), comment="成分股票名称"
    )
    in_date = Column(
        "in_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="纳入日期"
    )
    out_date = Column(
        "out_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="剔除日期"
    )
    is_new = Column("is_new", String(), nullable=False, default="", server_default=text("''"), comment="是否最新Y是N否")
