# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class IrmQaSh(Base):
    """上证e互动问答"""

    __tablename__: str = "irm_qa_sh"
    __api_id__: ClassVar[int] = 366
    __api_name__: ClassVar[str] = "irm_qa_sh"
    __api_title__: ClassVar[str] = "上证e互动问答"
    __api_info_title__: ClassVar[str] = "上证E互动"
    __api_path__: ClassVar[List[str]] = ["数据接口", "大模型语料专题数据", "上证e互动问答"]
    __api_path_ids__: ClassVar[List[int]] = [2, 142, 366]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "trade_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "股票代码"},
        "trade_date": {"type": "str", "required": False, "description": "交易日期（格式：YYYYMMDD，下同）"},
        "start_date": {"type": "str", "required": False, "description": "开始日期"},
        "end_date": {"type": "str", "required": False, "description": "结束日期"},
        "offset": {"type": "str", "required": False, "description": ""},
        "limit": {"type": "str", "required": False, "description": ""},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "上证e互动问答",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="股票代码")
    name = Column("name", String(), nullable=False, default="", server_default=text("''"), comment="公司名称")
    trade_date = Column(
        "trade_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="日期"
    )
    q = Column("q", String(), nullable=False, default="", server_default=text("''"), comment="问题")
    a = Column("a", String(), nullable=False, default="", server_default=text("''"), comment="回复")
    pub_time = Column(
        "pub_time",
        DateTime,
        nullable=False,
        default="1970-01-01 00:00:00",
        server_default=text("'1970-01-01 00:00:00'"),
        comment="回复时间",
    )
