# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class LimitList(Base):
    """每日涨跌停统计"""

    __tablename__: str = "limit_list"
    __api_id__: ClassVar[int] = 198
    __api_name__: ClassVar[str] = "limit_list"
    __api_title__: ClassVar[str] = "每日涨跌停统计"
    __api_info_title__: ClassVar[str] = "每日涨跌停统计"
    __api_path__: ClassVar[List[str]] = ["每日涨跌停统计"]
    __api_path_ids__: ClassVar[List[int]] = []
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "trade_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "trade_date": {"type": "str", "required": False, "description": "交易日期"},
        "ts_code": {"type": "str", "required": False, "description": "股票代码"},
        "limit_type": {"type": "str", "required": False, "description": "涨跌停类型U涨停D跌停"},
        "start_date": {"type": "str", "required": False, "description": "开始日期"},
        "end_date": {"type": "str", "required": False, "description": "结束日期"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "每日涨跌停统计",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    trade_date = Column(
        "trade_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="交易日期",
    )
    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="股票代码")
    name = Column("name", String(), nullable=False, default="", server_default=text("''"), comment="股票名称")
    close = Column("close", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="收盘价")
    pct_chg = Column("pct_chg", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="涨跌幅")
    amp = Column("amp", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="振幅")
    fc_ratio = Column(
        "fc_ratio", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="封单金额/日成交金额"
    )
    fl_ratio = Column(
        "fl_ratio", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="封单手数/流通股本"
    )
    fd_amount = Column(
        "fd_amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="封单金额"
    )
    first_time = Column(
        "first_time", String(), nullable=False, default="", server_default=text("''"), comment="首次涨停时间"
    )
    last_time = Column(
        "last_time", String(), nullable=False, default="", server_default=text("''"), comment="最后封板时间"
    )
    open_times = Column(
        "open_times", Integer, nullable=False, default=0, server_default=text("'0'"), comment="打开次数"
    )
    strth = Column("strth", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="强度")
    limit = Column("limit", String(), nullable=False, default="", server_default=text("''"), comment="D跌停U涨停")
