# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class NcovGlobal(Base):
    """全球新冠疫情数据"""

    __tablename__: str = "ncov_global"
    __api_id__: ClassVar[int] = 213
    __api_name__: ClassVar[str] = "ncov_global"
    __api_title__: ClassVar[str] = "全球新冠疫情数据"
    __api_info_title__: ClassVar[str] = "全球新冠疫情数据"
    __api_path__: ClassVar[List[str]] = ["全球新冠疫情数据"]
    __api_path_ids__: ClassVar[List[int]] = []
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["area_id", "publish_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "country": {"type": "str", "required": False, "description": "国家名称"},
        "province": {"type": "str", "required": False, "description": "省份简称（北京、上海）"},
        "publish_date": {"type": "datetime", "required": False, "description": "公布日期"},
        "start_date": {"type": "str", "required": False, "description": "开始日期（YYYYMMDD）"},
        "end_date": {"type": "str", "required": False, "description": "结束日期（YYYYMMDD）"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "全球新冠疫情数据",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    area_id = Column("area_id", String(), nullable=False, default="", server_default=text("''"), comment="地区代码")
    publish_date = Column(
        "publish_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="发布日期",
    )
    country = Column("country", String(), nullable=False, default="", server_default=text("''"), comment="国家")
    country_enname = Column(
        "country_enname", String(), nullable=False, default="", server_default=text("''"), comment="国家英文名"
    )
    province = Column("province", String(), nullable=False, default="", server_default=text("''"), comment="省份")
    province_short = Column(
        "province_short", String(), nullable=False, default="", server_default=text("''"), comment="省份简称"
    )
    province_enname = Column(
        "province_enname", String(), nullable=False, default="", server_default=text("''"), comment="省份英文名"
    )
    confirmed_num = Column(
        "confirmed_num", Integer, nullable=False, default=0, server_default=text("'0'"), comment="累计确诊病例"
    )
    confirmed_num_now = Column(
        "confirmed_num_now", Integer, nullable=False, default=0, server_default=text("'0'"), comment="现有确诊病例"
    )
    suspected_num = Column(
        "suspected_num", Integer, nullable=False, default=0, server_default=text("'0'"), comment="疑似感染病例"
    )
    cured_num = Column("cured_num", Integer, nullable=False, default=0, server_default=text("'0'"), comment="治愈人数")
    dead_num = Column("dead_num", Integer, nullable=False, default=0, server_default=text("'0'"), comment="死亡人数")
    update_time = Column(
        "update_time", String(), nullable=False, default="", server_default=text("''"), comment="更新时间"
    )
