# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class NcovNum(Base):
    """新冠状肺炎感染人数"""

    __tablename__: str = "ncov_num"
    __api_id__: ClassVar[int] = 202
    __api_name__: ClassVar[str] = "ncov_num"
    __api_title__: ClassVar[str] = "新冠状肺炎感染人数"
    __api_info_title__: ClassVar[str] = "新冠状肺炎感染人数"
    __api_path__: ClassVar[List[str]] = ["新冠状肺炎感染人数"]
    __api_path_ids__: ClassVar[List[int]] = []
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["area_name", "ann_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "area_name": {"type": "str", "required": False, "description": "地区名称"},
        "level": {"type": "str", "required": False, "description": "级别：2-中国内地，3-省级，4-地区市级别"},
        "ann_date": {"type": "str", "required": False, "description": "公告日期"},
        "start_date": {"type": "str", "required": False, "description": "查询开始日期"},
        "end_date": {"type": "str", "required": False, "description": "查询结束日期"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "新冠状肺炎感染人数",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ann_date = Column(
        "ann_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="发布日期"
    )
    area_name = Column("area_name", String(), nullable=False, default="", server_default=text("''"), comment="地区名称")
    parent_name = Column(
        "parent_name", String(), nullable=False, default="", server_default=text("''"), comment="上一级地区"
    )
    level = Column("level", Integer, nullable=False, default=0, server_default=text("'0'"), comment="级别")
    confirmed_num = Column(
        "confirmed_num", Integer, nullable=False, default=0, server_default=text("'0'"), comment="累计确诊人数"
    )
    suspected_num = Column(
        "suspected_num", Integer, nullable=False, default=0, server_default=text("'0'"), comment="累计疑似人数"
    )
    confirmed_num_now = Column(
        "confirmed_num_now", Integer, nullable=False, default=0, server_default=text("'0'"), comment="现有确诊人数"
    )
    suspected_num_now = Column(
        "suspected_num_now", Integer, nullable=False, default=0, server_default=text("'0'"), comment="现有疑似人数"
    )
    cured_num = Column(
        "cured_num", Integer, nullable=False, default=0, server_default=text("'0'"), comment="累计治愈人数"
    )
    dead_num = Column(
        "dead_num", Integer, nullable=False, default=0, server_default=text("'0'"), comment="累计死亡人数"
    )
