# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class NewShare(Base):
    """IPO新股上市"""

    __tablename__: str = "new_share"
    __api_id__: ClassVar[int] = 123
    __api_name__: ClassVar[str] = "new_share"
    __api_title__: ClassVar[str] = "IPO新股上市"
    __api_info_title__: ClassVar[str] = "IPO新股列表"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "基础数据", "IPO新股上市"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 24, 123]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = ["stock_basic"]
    __primary_key__: ClassVar[List[str]] = ["ts_code", "sub_code"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "start_date": {"type": "str", "required": False, "description": "开始日期"},
        "end_date": {"type": "str", "required": False, "description": "结束日期"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "IPO新股上市",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="TS股票代码")
    sub_code = Column("sub_code", String(), nullable=False, default="", server_default=text("''"), comment="申购代码")
    name = Column("name", String(), nullable=False, default="", server_default=text("''"), comment="名称")
    ipo_date = Column(
        "ipo_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="上网发行日期",
    )
    issue_date = Column(
        "issue_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="上市日期",
    )
    amount = Column(
        "amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="发行总量(万股)"
    )
    market_amount = Column(
        "market_amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="上网发行总量(万股)"
    )
    price = Column("price", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="发行价格")
    pe = Column("pe", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="市盈率")
    limit_amount = Column(
        "limit_amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="个人申购上限(万股)"
    )
    funds = Column("funds", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="募集资金(亿元)")
    ballot = Column("ballot", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="中签率")
