# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class ShiborQuote(Base):
    """Shibor报价数据"""

    __tablename__: str = "shibor_quote"
    __api_id__: ClassVar[int] = 150
    __api_name__: ClassVar[str] = "shibor_quote"
    __api_title__: ClassVar[str] = "Shibor报价数据"
    __api_info_title__: ClassVar[str] = "Shibor报价数据"
    __api_path__: ClassVar[List[str]] = ["数据接口", "宏观经济", "国内宏观", "利率数据", "Shibor报价数据"]
    __api_path_ids__: ClassVar[List[int]] = [2, 147, 224, 148, 150]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["date", "bank"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "date": {"type": "str", "required": False, "description": "日期"},
        "start_date": {"type": "str", "required": False, "description": "开始日期"},
        "end_date": {"type": "str", "required": False, "description": "结束日期"},
        "bank": {"type": "str", "required": False, "description": "银行名称"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "Shibor报价数据",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    date = Column("date", String(), nullable=False, default="", server_default=text("''"), comment="日期")
    bank = Column("bank", String(), nullable=False, default="", server_default=text("''"), comment="报价银行")
    on_b = Column("on_b", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="隔夜_Bid")
    on_a = Column("on_a", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="隔夜_Ask")
    _1w_b = Column("1w_b", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="1周_Bid")
    _1w_a = Column("1w_a", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="1周_Ask")
    _2w_b = Column("2w_b", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="2周_Bid")
    _2w_a = Column("2w_a", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="2周_Ask")
    _1m_b = Column("1m_b", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="1月_Bid")
    _1m_a = Column("1m_a", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="1月_Ask")
    _3m_b = Column("3m_b", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="3月_Bid")
    _3m_a = Column("3m_a", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="3月_Ask")
    _6m_b = Column("6m_b", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="6月_Bid")
    _6m_a = Column("6m_a", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="6月_Ask")
    _9m_b = Column("9m_b", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="9月_Bid")
    _9m_a = Column("9m_a", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="9月_Ask")
    _1y_b = Column("1y_b", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="1年_Bid")
    _1y_a = Column("1y_a", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="1年_Ask")
