# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class SlbLen(Base):
    """转融资交易汇总"""

    __tablename__: str = "slb_len"
    __api_id__: ClassVar[int] = 331
    __api_name__: ClassVar[str] = "slb_len"
    __api_title__: ClassVar[str] = "转融资交易汇总"
    __api_info_title__: ClassVar[str] = "转融资交易汇总"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "两融及转融通", "转融资交易汇总"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 330, 331]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = ["trade_cal"]
    __primary_key__: ClassVar[List[str]] = ["trade_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "trade_date": {"type": "str", "required": False, "description": "交易日期（YYYYMMDD格式，下同）"},
        "start_date": {"type": "str", "required": False, "description": "开始日期"},
        "end_date": {"type": "str", "required": False, "description": "开始日期"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "转融资交易汇总",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    trade_date = Column(
        "trade_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="交易日期(YYYYMMDD)",
    )
    ob = Column("ob", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="期初余额(亿元)")
    auc_amount = Column(
        "auc_amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="竞价成交金额(亿元)"
    )
    repo_amount = Column(
        "repo_amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="再借成交金额(亿元)"
    )
    repay_amount = Column(
        "repay_amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="偿还金额(亿元)"
    )
    cb = Column("cb", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="期末余额(亿元)")
