# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class StkManagers(Base):
    """上市公司管理层"""

    __tablename__: str = "stk_managers"
    __api_id__: ClassVar[int] = 193
    __api_name__: ClassVar[str] = "stk_managers"
    __api_title__: ClassVar[str] = "上市公司管理层"
    __api_info_title__: ClassVar[str] = "上市公司管理层"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "基础数据", "上市公司管理层"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 24, 193]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = ["stock_basic"]
    __primary_key__: ClassVar[List[str]] = ["ts_code", "ann_date", "name", "title"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "股票代码"},
        "ann_date": {"type": "str", "required": False, "description": "公告日期"},
        "start_date": {"type": "str", "required": False, "description": "公告开始日期"},
        "end_date": {"type": "str", "required": False, "description": "公告结束日期"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "上市公司管理层",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="TS股票代码")
    ann_date = Column(
        "ann_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="公告日期"
    )
    name = Column("name", String(), nullable=False, default="", server_default=text("''"), comment="姓名")
    gender = Column("gender", String(), nullable=False, default="", server_default=text("''"), comment="性别")
    lev = Column("lev", String(), nullable=False, default="", server_default=text("''"), comment="岗位类别")
    title = Column("title", String(), nullable=False, default="", server_default=text("''"), comment="岗位")
    edu = Column("edu", String(), nullable=False, default="", server_default=text("''"), comment="学历")
    national = Column("national", String(), nullable=False, default="", server_default=text("''"), comment="国籍")
    birthday = Column("birthday", String(), nullable=False, default="", server_default=text("''"), comment="出生年份")
    begin_date = Column(
        "begin_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="上任日期",
    )
    end_date = Column(
        "end_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="离任日期"
    )
    resume = Column("resume", String(), nullable=False, default="", server_default=text("''"), comment="个人简历")
