# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class StockCompany(Base):
    """上市公司基本信息"""

    __tablename__: str = "stock_company"
    __api_id__: ClassVar[int] = 112
    __api_name__: ClassVar[str] = "stock_company"
    __api_title__: ClassVar[str] = "上市公司基本信息"
    __api_info_title__: ClassVar[str] = "上市公司基本信息"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "基础数据", "上市公司基本信息"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 24, 112]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = ["stock_basic"]
    __primary_key__: ClassVar[List[str]] = ["ts_code"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "TS股票代码"},
        "exchange": {"type": "str", "required": False, "description": "交易所"},
        "status": {"type": "str", "required": False, "description": "状态"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "上市公司基本信息",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="股票代码")
    com_name = Column("com_name", String(), nullable=False, default="", server_default=text("''"), comment="公司全称")
    com_id = Column(
        "com_id", String(), nullable=False, default="", server_default=text("''"), comment="统一社会信用代码"
    )
    chairman = Column("chairman", String(), nullable=False, default="", server_default=text("''"), comment="法人代表")
    manager = Column("manager", String(), nullable=False, default="", server_default=text("''"), comment="总经理")
    secretary = Column("secretary", String(), nullable=False, default="", server_default=text("''"), comment="董秘")
    reg_capital = Column(
        "reg_capital", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="注册资本"
    )
    setup_date = Column(
        "setup_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="注册日期",
    )
    province = Column("province", String(), nullable=False, default="", server_default=text("''"), comment="所在省份")
    city = Column("city", String(), nullable=False, default="", server_default=text("''"), comment="所在城市")
    introduction = Column(
        "introduction", String(), nullable=False, default="", server_default=text("''"), comment="公司介绍"
    )
    website = Column("website", String(), nullable=False, default="", server_default=text("''"), comment="公司主页")
    email = Column("email", String(), nullable=False, default="", server_default=text("''"), comment="电子邮件")
    office = Column("office", String(), nullable=False, default="", server_default=text("''"), comment="办公室")
    ann_date = Column(
        "ann_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="公告日期"
    )
    business_scope = Column(
        "business_scope", String(), nullable=False, default="", server_default=text("''"), comment="经营范围"
    )
    employees = Column("employees", Integer, nullable=False, default=0, server_default=text("'0'"), comment="员工人数")
    main_business = Column(
        "main_business", String(), nullable=False, default="", server_default=text("''"), comment="主要业务及产品"
    )
    exchange = Column(
        "exchange",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="交易所代码SSE上交所 SZSE深交所 HKEX港交所",
    )
