# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class StockVx(Base):
    """估值因子"""

    __tablename__: str = "stock_vx"
    __api_id__: ClassVar[int] = 303
    __api_name__: ClassVar[str] = "stock_vx"
    __api_title__: ClassVar[str] = "估值因子"
    __api_info_title__: ClassVar[str] = "估值因子"
    __api_path__: ClassVar[List[str]] = ["估值因子"]
    __api_path_ids__: ClassVar[List[int]] = []
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "trade_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "股票代码"},
        "trade_date": {"type": "datetime", "required": False, "description": "交易日期"},
        "start_date": {"type": "str", "required": False, "description": "开始日期"},
        "end_date": {"type": "str", "required": False, "description": "结束日期"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "估值因子",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    trade_date = Column(
        "trade_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="交易日期",
    )
    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="股票代码")
    level1 = Column(
        "level1",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="4评级：1(便宜)、2(合理)、3(贵)、4(很贵)",
    )
    level2 = Column(
        "level2",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="8评级：1,2(便宜)、3,4(合理)、5,6(贵)、7,8(很贵)",
    )
    vx_life_v_l4 = Column(
        "vx_life_v_l4",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="估值长优4条线，根据level1的评级，公司上市后每一天的估值评级平均",
    )
    vx_3excellent_v_l4 = Column(
        "vx_3excellent_v_l4",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="估值3优4条线，根据level1的评级，最新季度的估值评级、近5季度的估值评级平均、上市后的估值评级平均，短中长的估值评级再取一次平均形成三优指标",
    )
    vx_past_5q_avg_l4 = Column(
        "vx_past_5q_avg_l4",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="估值4条线近5季平均，根据level1的评级，最近五季度估值评级平均",
    )
    vx_grow_worse_v_l4 = Column(
        "vx_grow_worse_v_l4",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="估值进退步-估值4条线,根据level1的评级，最新的估值评级与最近5Q平均的比",
    )
    vx_life_v_l8 = Column(
        "vx_life_v_l8",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="估值长优8条线,根据level2的评级，公司上市后每一季度的估值评级平均",
    )
    vx_3excellent_v_l8 = Column(
        "vx_3excellent_v_l8",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="估值3优8条线,根据level2的评级，最新季度的估值评级、近5季度的估值评级平均、上市后的估值评级平均，短中长的估值评级再取一次平均形成三优指标",
    )
    vx_past_5q_avg_l8 = Column(
        "vx_past_5q_avg_l8",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="估值8条线近5季平均,根据level2的评级，最近五季度估值评级平均",
    )
    vx_grow_worse_v_l8 = Column(
        "vx_grow_worse_v_l8",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="估值进退步-估值8条线,根据level2的评级，最新的估值评级与最近5Q平均的比较",
    )
    vxx = Column(
        "vxx",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="个股最新估值与亚洲同类股票相较后的标准差，按因子排序，数值越大代表估值越贵",
    )
    vs = Column(
        "vs",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="个股最新估值与亚洲同类股票自己相较后的标准差，按因子排序，数值越大代表估值越贵",
    )
    vz11 = Column(
        "vz11",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="个股最新估值与亚洲同类股票主行业相较后的标准差，按因子排序，数值越大代表估值越贵",
    )
    vz24 = Column(
        "vz24",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="个股最新估值与亚洲同类股票次行业相较后的标准差，按因子排序，数值越大代表估值越贵",
    )
    vz_lms = Column(
        "vz_lms",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="个股最新估值与亚洲同类股票市值分类相较后的标准差，按因子排序，数值越大代表估值越贵",
    )
