# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class ThsHot(Base):
    """同花顺App热榜数"""

    __tablename__: str = "ths_hot"
    __api_id__: ClassVar[int] = 320
    __api_name__: ClassVar[str] = "ths_hot"
    __api_title__: ClassVar[str] = "同花顺App热榜数"
    __api_info_title__: ClassVar[str] = "同花顺热板"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "打板专题数据", "同花顺App热榜数"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 346, 320]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = ["trade_cal"]
    __primary_key__: ClassVar[List[str]] = ["trade_date", "data_type", "ts_code", "rank_time"]
    __start_date__: ClassVar[str | None] = "2020-01-01"
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "trade_date": {"type": "str", "required": False, "description": "交易日期(格式：YYYYMMDD，下同)"},
        "ts_code": {"type": "str", "required": False, "description": "TS代码"},
        "market": {
            "type": "str",
            "required": False,
            "description": "热板类型(热股、ETF、可转债、行业板块、概念板块、期货、港股、热基、美股)",
        },
        "is_new": {"type": "str", "required": False, "description": "是否最新"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "同花顺App热榜数",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    trade_date = Column(
        "trade_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="交易日期",
    )
    data_type = Column("data_type", String(), nullable=False, default="", server_default=text("''"), comment="数据类型")
    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="股票代码")
    ts_name = Column("ts_name", String(), nullable=False, default="", server_default=text("''"), comment="股票名称")
    rank = Column("rank", Integer, nullable=False, default=0, server_default=text("'0'"), comment="排行或者热度")
    pct_change = Column(
        "pct_change", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="涨跌幅%"
    )
    current_price = Column(
        "current_price", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="当前价格"
    )
    hot = Column("hot", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="热度")
    concept = Column("concept", String(), nullable=False, default="", server_default=text("''"), comment="标签")
    rank_time = Column(
        "rank_time", String(), nullable=False, default="", server_default=text("''"), comment="排行榜获取时间"
    )
    rank_reason = Column(
        "rank_reason", String(), nullable=False, default="", server_default=text("''"), comment="上榜解读"
    )
