# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class ThsMember(Base):
    """同花顺行业概念成分"""

    __tablename__: str = "ths_member"
    __api_id__: ClassVar[int] = 261
    __api_name__: ClassVar[str] = "ths_member"
    __api_title__: ClassVar[str] = "同花顺行业概念成分"
    __api_info_title__: ClassVar[str] = "同花顺概念板块成分"
    __api_path__: ClassVar[List[str]] = ["数据接口", "股票数据", "打板专题数据", "同花顺行业概念成分"]
    __api_path_ids__: ClassVar[List[int]] = [2, 14, 346, 261]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "con_code", "is_new"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "板块指数代码"},
        "con_code": {"type": "str", "required": False, "description": "股票代码"},
        "offset": {"type": "str", "required": False, "description": ""},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "同花顺行业概念成分",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="指数代码")
    con_code = Column("con_code", String(), nullable=False, default="", server_default=text("''"), comment="股票代码")
    con_name = Column("con_name", String(), nullable=False, default="", server_default=text("''"), comment="股票名称")
    weight = Column("weight", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="权重")
    in_date = Column(
        "in_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="纳入日期"
    )
    out_date = Column(
        "out_date", Date, nullable=False, default="1970-01-01", server_default=text("'1970-01-01'"), comment="剔除日期"
    )
    is_new = Column("is_new", String(), nullable=False, default="", server_default=text("''"), comment="是否最新Y是N否")
