# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class TmtTwincome(Base):
    """台湾电子产业月营收"""

    __tablename__: str = "tmt_twincome"
    __api_id__: ClassVar[int] = 88
    __api_name__: ClassVar[str] = "tmt_twincome"
    __api_title__: ClassVar[str] = "台湾电子产业月营收"
    __api_info_title__: ClassVar[str] = "台湾电子产业月度营收"
    __api_path__: ClassVar[List[str]] = ["数据接口", "行业经济", "TMT行业", "台湾电子产业月营收"]
    __api_path_ids__: ClassVar[List[int]] = [2, 82, 83, 88]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["item", "date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "date": {"type": "str", "required": False, "description": "报告期"},
        "item": {"type": "str", "required": True, "description": "产品代码"},
        "start_date": {"type": "str", "required": False, "description": "报告期开始日期"},
        "end_date": {"type": "str", "required": False, "description": "报告期结束日期"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "台湾电子产业月营收",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    date = Column("date", String(), nullable=False, default="", server_default=text("''"), comment="报告期")
    item = Column("item", String(), nullable=False, default="", server_default=text("''"), comment="产品代码")
    op_income = Column("op_income", String(), nullable=False, default="", server_default=text("''"), comment="月度收入")
