# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class UsDailyAdj(Base):
    """美股复权行情"""

    __tablename__: str = "us_daily_adj"
    __api_id__: ClassVar[int] = 338
    __api_name__: ClassVar[str] = "us_daily_adj"
    __api_title__: ClassVar[str] = "美股复权行情"
    __api_info_title__: ClassVar[str] = "美股复权行情"
    __api_path__: ClassVar[List[str]] = ["数据接口", "美股数据", "美股复权行情"]
    __api_path_ids__: ClassVar[List[int]] = [2, 251, 338]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = True
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "trade_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "股票代码（e.g. AAPL）"},
        "trade_date": {"type": "str", "required": False, "description": "交易日期（YYYYMMDD）"},
        "start_date": {"type": "str", "required": False, "description": "开始日期（YYYYMMDD）"},
        "end_date": {"type": "str", "required": False, "description": "结束日期（YYYYMMDD）"},
        "exchange": {"type": "str", "required": False, "description": "交易所（NAS/NYS/OTC)"},
        "offset": {"type": "int", "required": False, "description": "开始行数"},
        "limit": {"type": "int", "required": False, "description": "每页行数行数"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "美股复权行情",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="股票代码")
    trade_date = Column(
        "trade_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="交易日期",
    )
    close = Column("close", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="收盘价")
    open = Column("open", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="开盘价")
    high = Column("high", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="最高价")
    low = Column("low", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="最低价")
    pre_close = Column("pre_close", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="昨收价")
    change = Column("change", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="涨跌额")
    pct_change = Column(
        "pct_change", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="涨跌幅"
    )
    vol = Column("vol", Integer, nullable=False, default=0, server_default=text("'0'"), comment="成交量")
    amount = Column("amount", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="成交额")
    vwap = Column("vwap", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="平均价")
    adj_factor = Column(
        "adj_factor", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="复权因子"
    )
    turnover_ratio = Column(
        "turnover_ratio", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="换手率"
    )
    free_share = Column(
        "free_share", Integer, nullable=False, default=0, server_default=text("'0'"), comment="流通股本"
    )
    total_share = Column(
        "total_share", Integer, nullable=False, default=0, server_default=text("'0'"), comment="总股本"
    )
    free_mv = Column("free_mv", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="流通市值")
    total_mv = Column("total_mv", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="总市值")
    exchange = Column("exchange", String(), nullable=False, default="", server_default=text("''"), comment="交易所代码")
