# This file is auto-generated by generate_models.py
# This file may be manually edited after generation
# The file has been formatted using isort and black

from typing import Any, ClassVar, Dict, List

from clickhouse_sqlalchemy import engines
from sqlalchemy import Column, PrimaryKeyConstraint, text

from tushare_models.core import Base, Date, DateTime, Float, Integer, String


class YcCb(Base):
    """国债收益率曲线"""

    __tablename__: str = "yc_cb"
    __api_id__: ClassVar[int] = 201
    __api_name__: ClassVar[str] = "yc_cb"
    __api_title__: ClassVar[str] = "国债收益率曲线"
    __api_info_title__: ClassVar[str] = "中债收益率曲线"
    __api_path__: ClassVar[List[str]] = ["数据接口", "债券专题", "国债收益率曲线"]
    __api_path_ids__: ClassVar[List[int]] = [2, 184, 201]
    __api_points_required__: ClassVar[int] = 2000
    __api_special_permission__: ClassVar[bool] = False
    __has_vip__: ClassVar[bool] = False
    __dependencies__: ClassVar[List[str]] = []
    __primary_key__: ClassVar[List[str]] = ["ts_code", "trade_date"]
    __start_date__: ClassVar[str | None] = None
    __end_date__: ClassVar[str | None] = None
    __api_params__: ClassVar[Dict[str, Any]] = {
        "ts_code": {"type": "str", "required": False, "description": "收益率曲线编码：1001.CB-国债收益率曲线"},
        "curve_type": {"type": "str", "required": False, "description": "曲线类型：0-到期，1-即期"},
        "trade_date": {"type": "str", "required": False, "description": "交易日期"},
        "start_date": {"type": "str", "required": False, "description": "查询起始日期"},
        "end_date": {"type": "str", "required": False, "description": "查询结束日期"},
        "curve_term": {"type": "str", "required": False, "description": "期限"},
        "limit": {"type": "int", "required": False, "description": "单次返回数据长度"},
        "offset": {"type": "int", "required": False, "description": "请求数据的开始位移量"},
    }

    __mapper_args__ = {"primary_key": __primary_key__}
    __table_args__ = (
        PrimaryKeyConstraint(*__primary_key__),
        # ClickHouse引擎
        engines.ReplacingMergeTree(order_by=__primary_key__),
        {
            "comment": "国债收益率曲线",
            # MySQL引擎
            "mysql_engine": "InnoDB",
            # StarRocks引擎
            "starrocks_primary_key": ",".join(__primary_key__),
            "starrocks_order_by": ",".join(__primary_key__),
            # Apache Doris引擎
            "doris_unique_key": __primary_key__,
            # Databend引擎
            "databend_cluster_by": __primary_key__,
        },
    )

    trade_date = Column(
        "trade_date",
        Date,
        nullable=False,
        default="1970-01-01",
        server_default=text("'1970-01-01'"),
        comment="交易日期",
    )
    ts_code = Column("ts_code", String(16), nullable=False, default="", server_default=text("''"), comment="曲线编码")
    curve_name = Column(
        "curve_name", String(), nullable=False, default="", server_default=text("''"), comment="曲线名称"
    )
    curve_type = Column(
        "curve_type",
        String(),
        nullable=False,
        default="",
        server_default=text("''"),
        comment="曲线类型：0-到期，1-即期",
    )
    curve_term = Column(
        "curve_term", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="期限(年)"
    )
    _yield = Column("yield", Float, nullable=False, default=0.0, server_default=text("'0.0'"), comment="收益率(%)")
